/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SOURCE_SEQUENCER_H_
#define __GDAM_SOURCE_SEQUENCER_H_


typedef struct _GdamSourceSequencer GdamSourceSequencer;
typedef struct _GdamSourceSequencerClass GdamSourceSequencerClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_source_sequencer_get_type();
#define GDAM_TYPE_SOURCE_SEQUENCER			(gdam_source_sequencer_get_type ())
#define GDAM_SOURCE_SEQUENCER(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SOURCE_SEQUENCER, GdamSourceSequencer))
#define GDAM_SOURCE_SEQUENCER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SOURCE_SEQUENCER, GdamSourceSequencerClass))
#define GDAM_IS_SOURCE_SEQUENCER(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SOURCE_SEQUENCER))
#define GDAM_IS_SOURCE_SEQUENCER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SOURCE_SEQUENCER))

typedef struct _GdamSourceSequencerElement GdamSourceSequencerElement;
struct _GdamSourceSequencerElement {
	GdamSource*		source;
	int			length;
	gboolean		is_playing;
	int			num_read;
	int			position;
};

struct _GdamSourceSequencerClass {
	GdamSourceClass		source_class;
};
struct _GdamSourceSequencer {
	GdamSource		source;

	GSList*			sorted_elements;
	GSList*			next_sorted;
	GSList*			playing_elements;
	int			position;
};



#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
